package jeops.conflict;

/*
 * JEOPS - The Java Embedded Object Production System
 * Copyright (c) 2000   Carlos Figueira Filho
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Contact: Carlos Figueira Filho (csff@cin.ufpe.br)
 */

/**
 * This class defines an exception that will be thrown when there aren't
 * more rules to be fired in a conflict set.
 *
 * @version 0.01  29 Mar 2000
 * @author Carlos Figueira Filho (<a href="mailto:csff@cin.ufpe.br">csff@cin.ufpe.br</a>)
 */
public class NoMoreElementsException extends Exception {

	/**
	 * Creates a new NoMoreElementsException, without a detailed message.
	 */
	public NoMoreElementsException() {
		super();
	}
	/**
	 * Creates a new NoMoreElementsException with a given detail message.
	 *
	 * @param s the detail message.
	 */
	public NoMoreElementsException(String s) {
		super(s);
	}
}
